import cPickle
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.mlab as mlab
import matplotlib
from matplotlib.ticker import FuncFormatter

import pylab

def printtime(mins,pos=0):
    h = float(mins)/float(60)
    hint = int(h)
    m = (h-hint)*60
    mint = int(m)
    s = (m-mint)*60
    sint = int(s)
    #return str(hint)+":"+str(mint)+":"+str(sint) 
    return "%d:%02d:%02d"%(hint,mint,sint)
    
if __name__ == "__main__":  
    
    filename = "jukola2013_1.pickle"
    label="Jukola 2013, 1st leg, 12.2 km"

    #filename = "jukola2013_2.pickle"
    #label="Jukola 2013, 2nd leg, 13.0 km"
    
    #filename = "jukola2013_3.pickle"
    #label="Jukola 2013, 3rd leg, 14.4 km"
    
    #filename = "jukola2013_4.pickle"
    #label="Jukola 2013, 4th leg, 7.8 km"
    
    #filename = "jukola2013_5.pickle"
    #label="Jukola 2013, 5th leg, 7.7 km"
    
    #filename = "jukola2013_6.pickle"
    #label="Jukola 2013, 6th leg, 11.7 km"
    
    #filename = "jukola2013_7.pickle"
    #label="Jukola 2013, 7th leg, 15.1 km"
    
    timelist = cPickle.load(open( filename, 'rb'))
    print " loaded ", len(timelist)," times from disk"
    
    fig = plt.figure()
    ax = fig.add_subplot(111)
    # histogram
    n, bins, patches = ax.hist( timelist , 200, normed=0, facecolor='green', alpha=0.75)

    ax.set_xlabel('Time')
    ax.set_ylabel('N')
    mu = np.average(timelist)
    std = np.std(timelist)
    
    pylab.text(3*60, 0.6*max(n), '%s\nN=%i\nmu=%s\nsigma=%s'%( label ,len(timelist), printtime(mu), printtime(std)))
    
    mux=[mu , mu] # position of mu-line
    muy=[0 , 450] # y-coords for mu-line
    splus=[mu+std , mu+std]  # +std line
    sminus=[mu-std , mu-std] # -std line
    plt.plot(mux,muy, 'r-')
    plt.plot(splus,muy, 'r--')
    plt.plot(sminus,muy, 'r--')
    
    # x-axis time labels
    locs = []
    tloc = 30
    locs.append(tloc)
    while tloc<7*60:
        tloc=tloc+15 # x-axis tickmarks every 15min
        locs.append(tloc)
        
    ax.xaxis.set_major_locator( matplotlib.ticker.FixedLocator( locs )  )

    formatter = FuncFormatter(printtime)
    ax.xaxis.set_major_formatter(formatter)
    fig.autofmt_xdate(rotation=90)
    
    # limits
    ax.set_xlim(0.5*60, 4*60)
    ax.set_ylim(0, 1.1*max(n))
    ax.grid(True)

    plt.savefig( label+"_fig.png")
    
    plt.show()
